<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'SummitHero',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    date: {
      type: String,
      required: false,
      default: '',
    },
  },
  data() {
    return {
      targetDate: new Date(this.date).getTime(),
      days: 0,
      hours: 0,
      minutes: 0,
      seconds: 0,
      countdownInterval: null,
    };
  },
  created() {
    this.calculateCountdown();
    this.countdownInterval = setInterval(this.calculateCountdown, 1000);
  },
  beforeDestroy() {
    clearInterval(this.countdownInterval);
  },
  methods: {
    calculateCountdown() {
      const now = new Date().getTime();
      const timeRemaining = this.targetDate - now;
      this.days = Math.floor(timeRemaining / (1000 * 60 * 60 * 24));
      this.hours = Math.floor(
        (timeRemaining % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60),
      );
      this.minutes = Math.floor(
        (timeRemaining % (1000 * 60 * 60)) / (1000 * 60),
      );
      this.seconds = Math.floor((timeRemaining % (1000 * 60)) / 1000);
      if (timeRemaining < 0) {
        clearInterval(this.countdownInterval);
      }
    },
  },
});
</script>

<template>
  <section class="summit-hero slp-py-96">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="6" class="slp-flex">
          <div class="summit-hero__body slp-my-24">
            <SlpTypography
              tag="h1"
              variant="heading1-bold"
              data-aos-offset="-500"
              >{{ data.title }}
            </SlpTypography>
            <SlpTypography
              tag="h2"
              variant="heading5"
              class="slp-mt-8 slp-mb-24"
              >{{ data.text }}
            </SlpTypography>
            <div class="summit-hero__action">
              <SlpButton
                variant="secondary"
                :href="data.primary_button.externalUrl"
              >
                {{ data.primary_button.text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="calendar-alt-2"
                  variant="marketing"
                  alt="calendar icon"
                />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn v-if="data.video" :cols="6" class="video-container">
          <video :src="data.video" class="video" controls></video>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="summit-countdown">
        <SlpContainer class="summit-countdown__body">
          <div class="time-container">
            <SlpTypography tag="h2" variant="heading2-bold"
              >{{ days }}
            </SlpTypography>
            <SlpTypography tag="p" class="text" variant="heading4"
              >days
            </SlpTypography>
          </div>
          <div class="time-container">
            <SlpTypography tag="h2" variant="heading2-bold"
              >{{ hours }}
            </SlpTypography>
            <SlpTypography tag="p" class="text" variant="heading4"
              >hours
            </SlpTypography>
          </div>
          <div class="time-container">
            <SlpTypography tag="h2" variant="heading2-bold"
              >{{ minutes }}
            </SlpTypography>
            <SlpTypography tag="p" class="text" variant="heading4"
              >minutes
            </SlpTypography>
          </div>
          <div class="time-container">
            <SlpTypography tag="h2" variant="heading2-bold"
              >{{ seconds }}
            </SlpTypography>
            <SlpTypography tag="p" class="text" variant="heading4"
              >seconds
            </SlpTypography>
          </div>
        </SlpContainer>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.summit-hero {
  background: url(/nuxt-images/events/summit/summit-background.png);
  color: $color-text-50;
  background-size: cover;
  background-repeat: no-repeat;
  background-position: center;
  .video-container {
    padding-left: $spacing-96;
  }
  .video {
    width: 100%;
    height: 100%;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-32 0 0 0;

    .slp-btn {
      width: 100%;
      justify-content: center;
    }
    .video-container {
      padding-left: 0;
      width: 100%;
      margin: $spacing-24 0;
    }
  }
}

.time-container {
  position: relative;
  &:after {
    background: $color-accent-500;
    content: '';
    left: 50%;
    position: absolute;
    height: 2px;
    bottom: -24px;
    transform: translate(-50%, -13px);
    width: 48px;
  }
}
.summit-countdown {
  padding-top: $spacing-96;

  &__body {
    position: relative;
    display: flex;
    justify-content: space-evenly;
    text-align: center;
  }

  @media (max-width: $breakpoint-md) {
    padding-bottom: $spacing-64;
    padding-top: 0;
    .time-container {
      width: 50%;
      margin-top: $spacing-48;
    }

    &__body {
      flex-wrap: wrap;
    }
  }
}
</style>
